﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using System.Collections.Specialized;


namespace DataGrid
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            this.gridGroupingControl1.AllowProportionalColumnSizing = true;

            #region DataSource
            DataCollection dataSource = new DataCollection();
            Random rand = new Random();
            int r = rand.Next(100);
            for (int i = 0; i < 20; i++)
            {
                dataSource.Add(new Data(r.ToString(), "Category" + r.ToString(), "Sample1", r.ToString() + "Data"));
                r = rand.Next(100);
            }
            this.gridGroupingControl1.DataSource = dataSource;
            #endregion


            this.gridGroupingControl1.TableDescriptor.Columns[1].Appearance.AnyRecordFieldCell.CellType = GridCellTypeName.ComboBox;
            StringCollection coll = new StringCollection();
            coll.Add("Sample1");
            coll.Add("Sample2");

            this.gridGroupingControl1.TableDescriptor.Columns[1].Appearance.AnyRecordFieldCell.ChoiceList = coll;

            this.gridGroupingControl1.TableDescriptor.Columns[2].Appearance.AnyRecordFieldCell.CellType = GridCellTypeName.ComboBox;
            this.gridGroupingControl1.TableDescriptor.Columns[1].Appearance.AnyRecordFieldCell.ChoiceList = coll;

            this.gridGroupingControl1.QueryCellStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventHandler(gridGroupingControl1_QueryCellStyleInfo);

            this.gridGroupingControl1.TableControlCurrentCellCloseDropDown += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPopupClosedEventHandler(gridGroupingControl1_TableControlCurrentCellCloseDropDown);
           
            this.gridGroupingControl1.ShowDefaultValuesInAddNewRecord = true;
            this.gridGroupingControl1.TableDescriptor.Fields["CategoryName"].DefaultValue = "Category12345";
            this.gridGroupingControl1.TableDescriptor.Fields["Description"].DefaultValue = "Sample2";
            this.gridGroupingControl1.TableDescriptor.Fields["CategoryID"].DefaultValue = "Sample1";
            this.gridGroupingControl1.TableDescriptor.Fields["SampleData"].DefaultValue = "SampleData12345";
        }

        void gridGroupingControl1_TableControlCurrentCellCloseDropDown(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPopupClosedEventArgs e)
        {
            e.TableControl.Table.CurrentRecordManager.EndEdit();
        }

        void gridGroupingControl1_QueryCellStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventArgs e)
        {
            if (e.TableCellIdentity != null && e.TableCellIdentity.Column != null
                && e.TableCellIdentity.Column.Name == "CategoryID"
                && e.TableCellIdentity.DisplayElement.Kind == Syncfusion.Grouping.DisplayElementKind.Record)
            {

                //Checks if the "Description" column is having value "Sample2"
                if (e.TableCellIdentity.DisplayElement.GetRecord().GetValue("Description").ToString() == "Sample2")
                {
                    //Hiding the ComboBox dropdown button
                    e.Style.ShowButtons = GridShowButtons.Hide;
                }
            }
        }
    }
}
